# coding: utf-8

"""
    FINBOURNE Horizon API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic.v1 import StrictStr, Field, BaseModel, Field, StrictStr, conlist 
from finbourne_horizon.models.open_figi_data import OpenFigiData

class OpenFigiSearchResult(BaseModel):
    """
    Response coming back from a search request to OpenFIGI  # noqa: E501
    """
    results: conlist(OpenFigiData) = Field(..., description="Enumerable list of OpenFIGI results")
    perm_id_uri:  Optional[StrictStr] = Field(None,alias="permIdUri", description="URI of the related PermID response, if requested") 
    __properties = ["results", "permIdUri"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OpenFigiSearchResult:
        """Create an instance of OpenFigiSearchResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in results (list)
        _items = []
        if self.results:
            for _item in self.results:
                if _item:
                    _items.append(_item.to_dict())
            _dict['results'] = _items
        # set to None if perm_id_uri (nullable) is None
        # and __fields_set__ contains the field
        if self.perm_id_uri is None and "perm_id_uri" in self.__fields_set__:
            _dict['permIdUri'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OpenFigiSearchResult:
        """Create an instance of OpenFigiSearchResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OpenFigiSearchResult.parse_obj(obj)

        _obj = OpenFigiSearchResult.parse_obj({
            "results": [OpenFigiData.from_dict(_item) for _item in obj.get("results")] if obj.get("results") is not None else None,
            "perm_id_uri": obj.get("permIdUri")
        })
        return _obj
